## OpenXRay-xray-16.zip

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)

message(STATUS "CMAKE_VERSION: ${CMAKE_VERSION}")

cmake_policy(SET CMP0048 NEW)
cmake_policy(SET CMP0095 NEW)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(utils)
calculate_xray_build_id(XRAY_BUILD_ID)

project(OpenXRay
    DESCRIPTION "OpenXRay is an improved version of the X-Ray Engine, \
                the game engine used in the world-famous S.T.A.L.K.E.R. game series by GSC Game World."
    VERSION 1.6.02.${XRAY_BUILD_ID}
    HOMEPAGE_URL "https://github.com/OpenXRay/xray-16"
    LANGUAGES CXX C
)

message(STATUS "CMAKE_PROJECT_VERSION: ${CMAKE_PROJECT_VERSION}")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

option(CMAKE_VERBOSE_MAKEFILE "Verbose build output" OFF)
message(STATUS "CMAKE_VERBOSE_MAKEFILE: ${CMAKE_VERBOSE_MAKEFILE}")

if (CMAKE_VERBOSE_MAKEFILE)
    set(CMAKE_EXECUTE_PROCESS_COMMAND_ECHO STDOUT)
endif()

if (CMAKE_VERSION VERSION_EQUAL "3.28.2" AND CMAKE_UNITY_BUILD)
    # https://gitlab.kitware.com/cmake/cmake/-/issues/25650
    message(WARNING "In CMake 3.28.2, precompiled headers are broken when Unity build is enabled. This breaks project from compiling. \
                     Please, update to CMake 3.28.3 or downgrade to 3.28.1.")
    set(CMAKE_UNITY_BUILD OFF)
endif()

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE)
endif()

# Redirecting the default installation path /usr/local to /usr no need to use -DCMAKE_INSTALL_PREFIX =/usr
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "/usr")
endif()

include(GNUInstallDirs)
include(packaging)

set_git_info()

# Output all libraries and executable to one folder
set(COMPILE_OUTPUT_FOLDER "${CMAKE_SOURCE_DIR}/bin/${CMAKE_SYSTEM_PROCESSOR}/${CMAKE_BUILD_TYPE}")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${COMPILE_OUTPUT_FOLDER}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${COMPILE_OUTPUT_FOLDER}")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${COMPILE_OUTPUT_FOLDER}")
set(CMAKE_PDB_OUTPUT_DIRECTORY "${COMPILE_OUTPUT_FOLDER}")
set(CMAKE_COMPILE_PDB_OUTPUT_DIRECTORY "${COMPILE_OUTPUT_FOLDER}")

if (DISABLE_PORTABLE_MODE)
    add_compile_definitions(DISABLE_PORTABLE_MODE)
endif()

set(CMAKE_BUILD_RPATH_USE_ORIGIN TRUE)
set(CMAKE_MACOSX_RPATH TRUE)

message(STATUS "CMAKE_SYSTEM_PROCESSOR: ${CMAKE_SYSTEM_PROCESSOR}")
if (CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64" OR CMAKE_SYSTEM_PROCESSOR STREQUAL "arm64")
    set(PROJECT_PLATFORM_ARM64 TRUE)
elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "armv*")
    set(PROJECT_PLATFORM_ARM TRUE)
elseif (CMAKE_SYSTEM_PROCESSOR STREQUAL "e2k")
    set(PROJECT_PLATFORM_E2K TRUE)
elseif (CMAKE_SYSTEM_PROCESSOR STREQUAL "ppc" OR CMAKE_SYSTEM_PROCESSOR STREQUAL "ppc64le")
    set(PROJECT_PLATFORM_PPC TRUE)
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
    set(MASTER_GOLD_DEFAULT_VALUE ON)
else()
    set(MASTER_GOLD_DEFAULT_VALUE OFF)
endif()
message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")

option(MASTER_GOLD "Build with MASTER_GOLD" ${MASTER_GOLD_DEFAULT_VALUE})
if (MASTER_GOLD)
    add_compile_definitions(MASTER_GOLD)
endif()
message(STATUS "MASTER_GOLD: ${MASTER_GOLD}")

option(STATIC_BUILD "Use static build" ${MASTER_GOLD})
if (STATIC_BUILD)
    # XXX: Uncomment only after build with XRAY_STATIC_BUILD is fixed
    #add_compile_definitions(XRAY_STATIC_BUILD)
endif()
message(STATUS "STATIC_BUILD: ${STATIC_BUILD}")

option(CMAKE_UNITY_BUILD "Use unity build" OFF)
message(STATUS "CMAKE_UNITY_BUILD: ${CMAKE_UNITY_BUILD}")

find_program(CCACHE_FOUND ccache)
if (CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    set(ENV{CCACHE_SLOPPINESS} pch_defines,time_macros)
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0 AND NOT PROJECT_PLATFORM_E2K)
        message(FATAL_ERROR "Building with a gcc version less than 8.0 is not supported.")
    elseif (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0 AND PROJECT_PLATFORM_E2K)
        message(FATAL_ERROR "Building with a MCST lcc version less than 1.25 is not supported.")
    endif()
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # XXX: Remove -fdelayed-template-parsing
    add_compile_options(
        -fdelayed-template-parsing
        -Wno-unused-command-line-argument
        -Wno-inconsistent-missing-override
    )
endif()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND NOT XRAY_USE_DEFAULT_CXX_LIB)
    if (NOT XRAY_CXX_LIB)
        include(CheckCXXCompilerFlag)
        CHECK_CXX_COMPILER_FLAG("-stdlib=libc++" LIBCPP_AVAILABLE)
        CHECK_CXX_COMPILER_FLAG("-stdlib=libstdc++" LIBSTDCPP_AVAILABLE)

        if (LIBCPP_AVAILABLE)
            set(XRAY_CXX_LIB "libc++" CACHE STRING "" FORCE)
        elseif (LIBSTDCPP_AVAILABLE)
            set(XRAY_CXX_LIB "libstdc++" CACHE STRING "" FORCE)
        else()
            message("Neither libstdc++ nor libc++ are available. Hopefully, system has another custom stdlib?")
        endif()
    endif()

    if (XRAY_CXX_LIB STREQUAL "libstdc++")
        add_compile_options(-stdlib=libstdc++)
    elseif (XRAY_CXX_LIB STREQUAL "libc++")
        add_compile_options(-stdlib=libc++)
        if (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
            add_compile_options(-lcxxrt)
        else()
            add_compile_options(-lc++abi)
        endif()
    endif()
endif()

add_compile_options(-Wno-attributes)
if (APPLE)
    add_compile_options(-Wl,-undefined,error)
else()
    add_compile_options(-Wl,--no-undefined)
endif()

# TODO test
option(USE_ADDRESS_SANITIZER "Use AddressSanitizer" OFF)

if (USE_ADDRESS_SANITIZER)
    add_compile_options(
        -fsanitize=address
        -fsanitize=leak
        -fsanitize=undefined
        -fno-omit-frame-pointer
        -fno-optimize-sibling-calls
        -fno-sanitize=vptr
    )

    add_link_options(
        $<$<CXX_COMPILER_ID:Clang>:-shared-libasan>
    )
endif()

message(STATUS "USE_ADDRESS_SANITIZER: ${USE_ADDRESS_SANITIZER}")

option(USE_LTO "Use Link Time Optimization" ${MASTER_GOLD})
if (USE_LTO)
    include(CheckIPOSupported)
    check_ipo_supported(RESULT LTO_SUPPORTED)

    if (LTO_SUPPORTED)
        # With clang cmake only enables '-flto=thin' but we want full LTO
        if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
            add_compile_options(-flto=full)
        else()
            set(CMAKE_INTERPROCEDURAL_OPTIMIZATION ON)
        endif()
    endif()
endif()

message(STATUS "USE_LTO: ${USE_LTO}")

if (PROJECT_PLATFORM_ARM)
    add_compile_options(-mfpu=neon)
elseif (PROJECT_PLATFORM_ARM64)
    #add_compile_options()
elseif (PROJECT_PLATFORM_E2K)
    add_compile_options(-Wno-unknown-pragmas)
elseif (PROJECT_PLATFORM_PPC)
    add_compile_options(
        -maltivec
        -mabi=altivec
    )
    add_compile_definitions(NO_WARN_X86_INTRINSICS)
else()
    add_compile_options(
        -mfpmath=sse
        -msse3
    )
endif()

if (XRAY_LINKER)
    add_link_options(-fuse-ld=${XRAY_LINKER})
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_compile_definitions(
        DEBUG
        MIXED
    )
    add_compile_options(-Og)
endif()

add_compile_definitions(
    _MT
    _CPPUNWIND
)

if (NOT WIN32)
    find_package(SDL2 2.0.18 REQUIRED)
    # Fix to support older SDL2
    # https://github.com/OpenXRay/xray-16/issues/1595
    if (NOT TARGET SDL2::SDL2 AND DEFINED SDL2_LIBRARIES)
        add_library(SDL2::SDL2 UNKNOWN IMPORTED)
        set_target_properties(
            SDL2::SDL2 PROPERTIES
            IMPORTED_LOCATION "${SDL2_LIBRARIES}"
            INTERFACE_INCLUDE_DIRECTORIES "${SDL2_INCLUDE_DIRS}"
        )
    endif()
    find_package(OpenAL REQUIRED)
    find_package(JPEG)
    find_package(Ogg REQUIRED)
    find_package(Vorbis REQUIRED)
    find_package(Theora REQUIRED)
    find_package(LZO REQUIRED)
    find_package(mimalloc NAMES mimalloc2 mimalloc2.0 mimalloc)
endif()

# Memory allocator option
if (mimalloc_FOUND)
    set(MEMORY_ALLOCATOR "mimalloc" CACHE STRING "Use specific memory allocator (mimalloc/standard)")
else()
    set(MEMORY_ALLOCATOR "standard" CACHE STRING "Use specific memory allocator (mimalloc/standard)")
endif()
set_property(CACHE MEMORY_ALLOCATOR PROPERTY STRINGS "mimalloc" "standard")

if (MEMORY_ALLOCATOR STREQUAL "mimalloc" AND NOT mimalloc_FOUND)
    message(FATAL_ERROR "mimalloc allocator requested but not found. Please, install mimalloc package or select standard allocator.")
endif()

message("Using ${MEMORY_ALLOCATOR} memory allocator")

option(XRAY_USE_LUAJIT "Use LuaJIT" ON)

add_subdirectory(Externals)

add_compile_options(
    -Wall
    #-Werror
    -Wextra
    #-pedantic
    -Wno-unknown-pragmas
    -Wno-strict-aliasing
    -Wno-parentheses
    -Wno-unused-label
    -Wno-unused-parameter
    -Wno-switch
    #-Wno-padded
    #-Wno-c++98-compat
    #-Wno-c++98-compat-pedantic
    #-Wno-c++11-compat
    #-Wno-c++11-compat-pedantic
    #-Wno-c++14-compat
    #-Wno-c++14-compat-pedantic
    #-Wno-newline-eof
    $<$<CXX_COMPILER_ID:GNU>:$<$<COMPILE_LANGUAGE:CXX>:-Wno-class-memaccess>>
    $<$<CXX_COMPILER_ID:GNU>:$<$<COMPILE_LANGUAGE:CXX>:-Wno-interference-size>>
)

add_subdirectory(src)
add_subdirectory(res)
add_subdirectory(misc)

get_property(LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)

if ("${LIB64}" STREQUAL "TRUE")
    set(LIBSUFFIX 64)
else()
    set(LIBSUFFIX "")
endif()

=== Externals/CMakeLists.txt ===
if (XRAY_USE_LUAJIT)
    add_subdirectory(LuaJIT-proj)
else()
    find_package(Lua51 REQUIRED)
endif()

add_subdirectory(xrLuaFix)
add_subdirectory(luabind)
add_subdirectory(GameSpy)
add_subdirectory(OPCODE)
add_subdirectory(ode)
add_subdirectory(imgui-proj)

if (NOT TARGET xrLuabind)
    message(FATAL_ERROR
        "You probably have downloaded OpenXRay sources as ZIP archive, you can't do that. Use git to clone the repository.\n"
        "Read the build instructions: https://github.com/OpenXRay/xray-16/wiki"
    )
endif()

=== misc/CMakeLists.txt ===
project(xrResources)

install(DIRECTORY linux/bash-completion DESTINATION ${CMAKE_INSTALL_DATAROOTDIR})

install(FILES linux/openxray_cop.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
install(FILES linux/openxray_cs.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
install(FILES linux/openxray_soc.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

install(FILES media/icons/16x16/openxray_cop.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps)
install(FILES media/icons/32x32/openxray_cop.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps)
install(FILES media/icons/48x48/openxray_cop.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps)
install(FILES media/icons/64x64/openxray_cop.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps)
install(FILES media/icons/64x64/openxray_cop.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pixmaps)

install(FILES media/icons/16x16/openxray_cs.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps)
install(FILES media/icons/32x32/openxray_cs.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps)
install(FILES media/icons/48x48/openxray_cs.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps)
install(FILES media/icons/64x64/openxray_cs.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps)
install(FILES media/icons/64x64/openxray_cs.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pixmaps)

install(FILES media/icons/16x16/openxray_soc.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps)
install(FILES media/icons/32x32/openxray_soc.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps)
install(FILES media/icons/48x48/openxray_soc.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps)
install(FILES media/icons/64x64/openxray_soc.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps)
install(FILES media/icons/64x64/openxray_soc.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pixmaps)

=== res/CMakeLists.txt ===
project(xrGamedata)

install(FILES fsgame.ltx DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/openxray) 

install(DIRECTORY gamedata DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/openxray)

=== src/CMakeLists.txt ===
add_subdirectory(utils)
add_subdirectory(Layers)
add_subdirectory(xr_3da)
add_subdirectory(xrAICore)
add_subdirectory(xrUICore)
add_subdirectory(xrCDB)
add_subdirectory(xrCore)
add_subdirectory(xrEngine)
add_subdirectory(xrGame)
add_subdirectory(xrGameSpy)
add_subdirectory(xrMaterialSystem)
add_subdirectory(xrNetServer)
add_subdirectory(xrParticles)
add_subdirectory(xrPhysics)
add_subdirectory(xrScriptEngine)
add_subdirectory(xrSound)

=== Externals/LuaJIT-proj/CMakeLists.txt ===
# Copyright (C) 2007-2013 LuaDist.
# Created by Peter Drahoš
# Redistribution and use of this file is allowed according to the terms of the MIT license.
# For details see the COPYRIGHT file distributed with LuaDist.
# Please note that the package source code is licensed under its own license.

cmake_minimum_required(VERSION 3.13)

project(xrLuaJIT C CXX ASM)

# Version
set(MAJVER 2)
set(MINVER 0)
set(RELVER 5)
set(ABIVER 5.1)
set(NODOTABIVER 51)

set(CMAKE_OSX_SYSROOT "/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX.sdk")
set(LUAJIT_DIR ${CMAKE_SOURCE_DIR}/Externals/LuaJIT/src CACHE PATH "Location of luajit sources")

option(LUAJIT_BUILD_STATIC_LIB "Build as static library" OFF)
option(LUAJIT_BUILD_APP "Build application" OFF)

# NOTE: Not working because there is no lib_package_rel.c file
option(LUA_USE_RELATIVE_LOADLIB "Use modified loadlib.c with support for relative paths on posix systems (Not working)" OFF)

# Extra flags
option(LUAJIT_DISABLE_FFI "Disable the FFI extension to reduce the size of the LuaJIT executable. But please consider that the FFI library is compiled-in, but NOT loaded by default. It only allocates any memory, if you actually make use of it" OFF)
option(LUAJIT_ENABLE_LUA52COMPAT "Features from Lua 5.2 that are unlikely to break existing code are enabled by default. Some other features that *might* break some existing code (e.g. __pairs or os.execute() return values) can be enabled here. Note: this does not provide full compatibility with Lua 5.2 at this time" OFF)
option(LUAJIT_DISABLE_JIT "Disable the JIT compiler, i.e. turn LuaJIT into a pure interpreter" OFF)
option(LUAJIT_DISABLE_GC64 "Disable LJ_GC64 mode for x64" OFF)
option(LUAJIT_USE_SYSMALLOC "Use the system provided memory allocator (realloc) instead of the bundled memory allocator. This is slower, but sometimes helpful for debugging. It's helpful for Valgrind's memcheck tool, too. This option cannot be enabled on x64, since the built-in allocator is mandatory" OFF)
option(LUAJIT_USE_VALGRIND "This option is required to run LuaJIT under Valgrind. The Valgrind header files must be installed. You should enable debug information, too." OFF)
option(LUAJIT_USE_GDBJIT "This is the client for the GDB JIT API. GDB 7.0 or higher is required to make use of it. See lj_gdbjit.c for details. Enabling this causes a non-negligible overhead, even when not running under GDB" OFF)

option(LUA_USE_APICHECK "Turn on assertions for the Lua/C API to debug problems with lua_* calls. This is rather slow, use only while developing C libraries/embeddings" OFF)
option(LUA_USE_ASSERT "Turn on assertions for the whole LuaJIT VM. This significantly slows down everything. Use only if you suspect a problem with LuaJIT itself" OFF)

#option(LUAJIT_DEBUG "Generate debug information" OFF)

if (WIN32)
    option(LUA_BUILD_WLUA "Build wluajit interpreter for no-console applications." ON)
elseif (APPLE)
    option(LUA_USE_POSIX "Use POSIX functionality." ON)
    option(LUA_USE_DLOPEN "Use dynamic linker to load modules." ON)
else()
    option(LUA_USE_POSIX "Use POSIX functionality." ON)

    # OpenBSD has dl as a part of libc
    # NetBSD includes dl functions automatically
    if (NOT CMAKE_SYSTEM_NAME STREQUAL "OpenBSD" AND NOT CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
        # This option only links dl and doesn't change anything other from that.
        option(LUA_USE_DLOPEN "Use dynamic linker to load modules." ON)
    endif()
endif()

# TODO: check if we need luaconf.h
# TODO: add other variables from luaconf.h if we need them
# Configuration for luaconf.h
set(LUA_PATH "LUA_PATH" CACHE STRING "Environment variable to use as package.path")
set(LUA_CPATH "LUA_CPATH" CACHE STRING "Environment variable to use as package.cpath")
set(LUA_INIT "LUA_INIT" CACHE STRING "Environment variable for initial script")

if (APPLE)
    set(ENV{SDKROOT} ${CMAKE_OSX_SYSROOT})
    set(ENV{MACOSX_DEPLOYMENT_TARGET} ${CMAKE_OSX_DEPLOYMENT_TARGET})
endif()

# Clean unnecessary files in LuaJIT source directory
execute_process(
    COMMAND make clean
    WORKING_DIRECTORY ${LUAJIT_DIR}
)

# TODO: check windows supports same target name for static and shared lib
if (LUAJIT_BUILD_STATIC_LIB)
    add_library(xrLuaJIT STATIC)
else()
    add_library(xrLuaJIT SHARED)
endif()

# Compiler options
if (PROJECT_PLATFORM_E2K) # E2K: O3 on mcst-lcc approximately equal to O2 at gcc X86/ARM
    set(CCOPT_OPT_LEVEL "-O3")
else()
    set(CCOPT_OPT_LEVEL "-O2")
endif()

set(CCOPT "${CMAKE_C_FLAGS} ${CCOPT_OPT_LEVEL}")

if (USE_ADDRESS_SANITIZER)
    set(CCOPT "${CCOPT} -fno-stack-protector")
else()
    set(CCOPT "${CCOPT} -fomit-frame-pointer -fno-stack-protector")
endif()

set(CCOPT "${CCOPT} -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -U_FORTIFY_SOURCE")

string(REPLACE " " ";" CCOPT "${CCOPT}")

add_compile_options(
    #-Wdeclaration-after-statement
    #-Wredundant-decls
    #-Wshadow
    #-Wpointer-arith
)

if (LUAJIT_DISABLE_FFI)
    list(APPEND XCFLAGS "-DLUAJIT_DISABLE_FFI")
endif()

if (LUAJIT_ENABLE_LUA52COMPAT)
    list(APPEND XCFLAGS "-DLUAJIT_ENABLE_LUA52COMPAT")
endif()

if (LUAJIT_DISABLE_JIT)
    list(APPEND XCFLAGS "-DLUAJIT_DISABLE_JIT")
endif()

if (LUAJIT_DISABLE_GC64)
    list(APPEND XCFLAGS "-DLUAJIT_DISABLE_GC64")
endif()

if (LUAJIT_USE_SYSMALLOC)
    list(APPEND XCFLAGS "-DLUAJIT_USE_SYSMALLOC")
endif()

if (LUAJIT_USE_VALGRIND)
    list(APPEND XCFLAGS "-DLUAJIT_USE_VALGRIND")
endif()

if (LUAJIT_USE_GDBJIT)
    list(APPEND XCFLAGS "-DLUAJIT_USE_GDBJIT")
endif()

if (LUA_USE_APICHECK)
    list(APPEND XCFLAGS "-DLUA_USE_APICHECK")
endif()

if (LUA_USE_ASSERT)
    list(APPEND XCFLAGS "-DLUA_USE_ASSERT")
endif()

set(CCOPTIONS "${CCOPT};${XCFLAGS}")

target_compile_options(xrLuaJIT PRIVATE ${CCOPTIONS})

execute_process(
    COMMAND ${CMAKE_C_COMPILER} ${CCOPTIONS} -E lj_arch.h -dM
    WORKING_DIRECTORY "${LUAJIT_DIR}"
    OUTPUT_VARIABLE TESTARCH_OUTPUT
    ERROR_VARIABLE TESTARCH_ERROR
)

if(NOT "${TESTARCH_ERROR}" STREQUAL "")
    message("TESTARCH_ERROR=${TESTARCH_ERROR}")
endif()

if ("${TESTARCH_OUTPUT}" MATCHES "LJ_TARGET_X64")
    set(TARGET_LJARCH "x64")
elseif ("${TESTARCH_OUTPUT}" MATCHES "LJ_TARGET_X86")
    set(TARGET_LJARCH "x86")

    string(APPEND TARGET_XCFLAGS " -march=i686 -msse -msse2 -mfpmath=sse")
elseif ("${TESTARCH_OUTPUT}" MATCHES "LJ_TARGET_ARM64")
    set(TARGET_LJARCH "arm64")
    if ("${TESTARCH_OUTPUT}" MATCHES "__AARCH64EB__")
        set(TARGET_ARCH "-D__AARCH64EB__=1")
    endif()
elseif ("${TESTARCH_OUTPUT}" MATCHES "LJ_TARGET_ARM")
    set(TARGET_LJARCH "arm")
elseif ("${TESTARCH_OUTPUT}" MATCHES "LJ_TARGET_PPC")
    set(TARGET_LJARCH "ppc")
elseif ("${TESTARCH_OUTPUT}" MATCHES "LJ_TARGET_MIPS")
    if ("${TESTARCH_OUTPUT}" MATCHES "MIPSEL")
        set(TARGET_ARCH "-D__MIPSEL__=1")
    endif()
    if ("${TESTARCH_OUTPUT}" MATCHES "LJ_TARGET_MIPS64")
        set(TARGET_LJARCH "mips64")
    else()
        set(TARGET_LJARCH "mips")
    endif()
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "e2k") # MCST Elbrus 2000
    set(TARGET_LJARCH "e2k")
else()
    message("${TESTARCH_OUTPUT}")
    message(FATAL_ERROR "Unsupported luajit target architecture (see output above)")
endif()

string(APPEND TARGET_ARCH "-DLUAJIT_TARGET=LUAJIT_ARCH_${TARGET_LJARCH}")

# TODO: add PREFIX, TARGET_XCFLAGS, TARGET_DYNXLDOPTS, MULTILIB here (lines 289-302 in Makefile)
# TODO: use TARGET_STRIP flags?

if (WIN32)
    #string(APPEND TARGET_STRIP "--strip-unneeded")

    target_link_options(xrLuaJIT
        PRIVATE
        " -shared -Wl,--out-implib,libluajit-${ABIVER}.dll.a"
    )

    if (NOT LUAJIT_BUILD_STATIC_LIB)
        string(APPEND HOST_XCFLAGS " -DLUA_BUILD_AS_DLL")
    endif()

    set(LJVM_MODE peobj)
elseif (APPLE)
    if (CMAKE_OSX_DEPLOYMENT_TARGET STREQUAL "")
        message(FATAL_ERROR "Missing export MACOSX_DEPLOYMENT_TARGET=XX.YY")
    endif()

    #string(APPEND TARGET_STRIP "-x")
    # XXX: doesn't compile with Apple Clang
    #string(APPEND TARGET_XSHLDFLAGS " -dynamiclib -single_module -undefined dynamic_lookup -fPIC")
    #string(APPEND TARGET_XSHLDFLAGS " -install_name ${TARGET_DYLIBPATH} -compatibility_version ${MAJVER}.${MINVER} -current_version ${MAJVER}.${MINVER}.${RELVER}")

    if (${TARGET_LJARCH} STREQUAL "x64")
        string(APPEND TARGET_XLDFLAGS " -pagezero_size 10000 -image_base 100000000 -image_base 7fff04c4a000")
    elseif (${TARGET_LJARCH} STREQUAL "arm64")
        string(APPEND TARGET_XCFLAGS " -fno-omit-frame-pointer")
    endif()

    set(LJVM_MODE machasm)
else()
    set(LJVM_MODE elfasm)
endif()

# TODO: add HOST_SYS != TARGET_SYS code (lines 354-372 in Makefile)
#string(APPEND HOST_XCFLAGS "-DLUA_BUILD_AS_DLL -DLUAJIT_OS=LUAJIT_OS_WINDOWS")
# TODO: add "-DTARGET_OS_IPHONE=1" on iOS
#string(APPEND HOST_XCFLAGS "-DLUAJIT_OS=LUAJIT_OS_OSX")

# NOTE: Defines in DASM_FLAGS should contain a space after -D for minilua to work

if ("${TESTARCH_OUTPUT}" MATCHES "LJ_LE 1")
    list(APPEND DASM_FLAGS "-D ENDIAN_LE")
else()
    list(APPEND DASM_FLAGS "-D ENDIAN_BE")
endif()

if ("${TESTARCH_OUTPUT}" MATCHES "LJ_ARCH_BITS 64")
    list(APPEND DASM_FLAGS "-D P64")
endif()

if ("${TESTARCH_OUTPUT}" MATCHES "LJ_HASJIT 1")
    list(APPEND DASM_FLAGS "-D JIT")
endif()

if ("${TESTARCH_OUTPUT}" MATCHES "LJ_HASFFI 1")
    list(APPEND DASM_FLAGS "-D FFI")
endif()

if ("${TESTARCH_OUTPUT}" MATCHES "LJ_DUALNUM 1")
    list(APPEND DASM_FLAGS "-D DUALNUM")
endif()

if ("${TESTARCH_OUTPUT}" MATCHES "LJ_ARCH_HASFPU 1")
    list(APPEND DASM_FLAGS "-D FPU")
    list(APPEND TARGET_ARCH "-DLJ_ARCH_HASFPU=1")
else()
    list(APPEND TARGET_ARCH "-DLJ_ARCH_HASFPU=0")
endif()

if ("${TESTARCH_OUTPUT}" MATCHES "LJ_ABI_SOFTFP 1")
    list(APPEND TARGET_ARCH "-DLJ_ABI_SOFTFP=1")
else()
    list(APPEND DASM_FLAGS "-D HFABI")
    list(APPEND TARGET_ARCH "-DLJ_ABI_SOFTFP=0")
endif()

if ("${TESTARCH_OUTPUT}" MATCHES "LJ_NO_UNWIND 1")
    list(APPEND DASM_FLAGS "-D NO_UNWIND")
    list(APPEND TARGET_ARCH "-DLUAJIT_NO_UNWIND")
endif()

if ("${TESTARCH_OUTPUT}" MATCHES "LJ_ARCH_VERSION")
    string(REGEX MATCH "LJ_ARCH_VERSION ([0-9]+)$" _ "${TESTARCH_OUTPUT}")
    list(APPEND DASM_FLAGS "-D VER=${CMAKE_MATCH_1}")
else()
    list(APPEND DASM_FLAGS "-D VER=")
endif()

set(DASM_ARCH ${TARGET_LJARCH})

if (WIN32)
    list(APPEND DASM_FLAGS "-D WIN")
endif()

if (TARGET_LJARCH STREQUAL "x64")
    if (NOT "${TESTARCH_OUTPUT}" MATCHES "LJ_FR2 1")
        set(DASM_ARCH "x86")
    endif()
elseif (TARGET_LJARCH STREQUAL "arm")
    if (APPLE)
        list(APPEND DASM_FLAGS "-D IOS")
    endif()
elseif ("${TESTARCH_OUTPUT}" MATCHES "LJ_TARGET_MIPSR6")
    list(APPEND DASM_FLAGS "-D MIPSR6")
endif()

if (TARGET_LJARCH STREQUAL "ppc")
    if ("${TESTARCH_OUTPUT}" MATCHES "LJ_ARCH_SQRT 1")
        list(APPEND DASM_FLAGS "-D SQRT")
    endif()
    if ("${TESTARCH_OUTPUT}" MATCHES "LJ_ARCH_ROUND 1")
        list(APPEND DASM_FLAGS "-D ROUND")
    endif()
    if ("${TESTARCH_OUTPUT}" MATCHES "LJ_ARCH_PPC32ON64 1")
        list(APPEND DASM_FLAGS "-D GPR64")
    endif()
    if ("${TESTARCH_OUTPUT}" MATCHES "LJ_ARCH_PPC64")
        set(DASM_ARCH "ppc64")
    endif()
endif()

set(HOST_ACFLAGS "${CMAKE_C_FLAGS} ${CCOPTIONS} ${TARGET_ARCH}")
set(HOST_ALDFLAGS "${CMAKE_C_FLAGS}")

string(APPEND TARGET_XCFLAGS " -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -U_FORTIFY_SOURCE")

separate_arguments(HOST_ACFLAGS)
separate_arguments(HOST_ALDFLAGS)
separate_arguments(DASM_FLAGS)
separate_arguments(TARGET_XCFLAGS)

target_compile_options(xrLuaJIT
    PRIVATE
    ${TARGET_XCFLAGS}
)

set(DASM_DASC "${LUAJIT_DIR}/vm_${DASM_ARCH}.dasc")
set(DASM "${LUAJIT_DIR}/../dynasm/dynasm.lua")

if (PROJECT_PLATFORM_E2K)
    set(BUILDVM_ARCH "${LUAJIT_DIR}/host/buildvm_arch.h")
else()
    set(BUILDVM_ARCH "${CMAKE_CURRENT_BINARY_DIR}/buildvm_arch.h")
endif()

# Generate buildvm arch header
if (NOT PROJECT_PLATFORM_E2K)
    set(MINILUA_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/HostBuildTools/minilua")

=== Externals/OPCODE/CMakeLists.txt ===
if (STATIC_BUILD)
    add_library(xrOPCODE STATIC)

    target_compile_definitions(xrOPCODE
        PRIVATE
        OPCODE_STATIC
    )
else()
    add_library(xrOPCODE SHARED)
endif()

target_sources(xrOPCODE PRIVATE
    OPC_AABBCollider.cpp
    OPC_AABBCollider.h
    OPC_AABB.cpp
    OPC_AABB.h
    OPC_AABBTree.cpp
    OPC_AABBTree.h
    OPC_BoundingSphere.h
    OPC_BoxBoxOverlap.h
    OPC_BVTCache.h
    OPC_Collider.cpp
    OPC_Collider.h
    OPC_Common.cpp
    OPC_Common.h
    OPC_Container.cpp
    OPC_Container.h
    OPC_FPU.h
    OPC_Matrix3x3.cpp
    OPC_Matrix3x3.h
    OPC_Matrix4x4.cpp
    OPC_Matrix4x4.h
    OPC_MemoryMacros.h
    OPC_Model.cpp
    OPC_Model.h
    OPC_OBBCollider.cpp
    OPC_OBBCollider.h
    OPC_OBB.cpp
    OPC_OBB.h
    Opcode.cpp
    Opcode.h
    OPC_OptimizedTree.cpp
    OPC_OptimizedTree.h
    OPC_Plane.cpp
    OPC_Plane.h
    OPC_PlanesAABBOverlap.h
    OPC_PlanesCollider.cpp
    OPC_PlanesCollider.h
    OPC_PlanesTriOverlap.h
    OPC_Point.cpp
    OPC_Point.h
    OPC_Preprocessor.h
    OPC_RayAABBOverlap.h
    OPC_RayCollider.cpp
    OPC_RayCollider.h
    OPC_Ray.cpp
    OPC_Ray.h
    OPC_RayTriOverlap.h
    OPC_Settings.h
    OPC_SphereAABBOverlap.h
    OPC_SphereCollider.cpp
    OPC_SphereCollider.h
    OPC_SphereTriOverlap.h
    OPC_TreeBuilders.cpp
    OPC_TreeBuilders.h
    OPC_TreeCollider.cpp
    OPC_TreeCollider.h
    OPC_Triangle.cpp
    OPC_Triangle.h
    OPC_TriBoxOverlap.h
    OPC_TriTriOverlap.h
    OPC_Types.h
    OPC_VolumeCollider.cpp
    OPC_VolumeCollider.h
    pch.cpp
    pch.hpp
)

target_include_directories(xrOPCODE
    PRIVATE
    "${CMAKE_SOURCE_DIR}/src"
)

target_link_libraries(xrOPCODE
    PRIVATE
    xrCore
)

target_compile_definitions(xrOPCODE
    PRIVATE
    OPCODE_EXPORTS
)

set_target_properties(xrOPCODE PROPERTIES
    PREFIX ""
    POSITION_INDEPENDENT_CODE ON
)

target_precompile_headers(xrOPCODE
    PRIVATE
    pch.hpp
)

if (NOT STATIC_BUILD)
    install(TARGETS xrOPCODE LIBRARY
        DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    )
endif()

=== Externals/imgui-proj/CMakeLists.txt ===
add_library(xrImGui STATIC)

set(IMGUI_DIR "${CMAKE_SOURCE_DIR}/Externals/imgui")

target_sources(xrImGui PRIVATE
    "${IMGUI_DIR}/imconfig.h"
    "${IMGUI_DIR}/imgui.cpp"
    "${IMGUI_DIR}/imgui.h"
    "${IMGUI_DIR}/imgui_demo.cpp"
    "${IMGUI_DIR}/imgui_draw.cpp"
    "${IMGUI_DIR}/imgui_tables.cpp"
    "${IMGUI_DIR}/imgui_widgets.cpp"
    "${IMGUI_DIR}/imgui_internal.h"
    "${IMGUI_DIR}/backends/imgui_impl_opengl3.cpp"
    "${IMGUI_DIR}/backends/imgui_impl_opengl3.h"
    "${IMGUI_DIR}/imstb_rectpack.h"
    "${IMGUI_DIR}/imstb_textedit.h"
    "${IMGUI_DIR}/imstb_truetype.h"
)

target_include_directories(xrImGui
    PUBLIC
    "${IMGUI_DIR}"
)

if (NOT CMAKE_SYSTEM_NAME STREQUAL "OpenBSD" AND NOT CMAKE_SYSTEM_NAME STREQUAL "NetBSD" AND NOT WIN32)
    target_link_libraries(xrImGui
        PRIVATE
        $<$<NOT:$<PLATFORM_ID:OpenBSD>>:dl>
    )
endif()

target_compile_definitions(xrImGui
    PRIVATE
    IMGUI_EXPORTS
)

set_target_properties(xrImGui PROPERTIES
    PREFIX ""
    POSITION_INDEPENDENT_CODE ON
)

=== Externals/ode/CMakeLists.txt ===
if (STATIC_BUILD)
    add_library(xrODE STATIC)
else()
    add_library(xrODE SHARED)
endif()

target_sources(xrODE PRIVATE
    ode/src/array.cpp
    ode/src/array.h
    ode/src/Bounder33.cpp
    ode/src/Bounder33.h
    ode/src/collision_kernel.cpp
    ode/src/collision_kernel.h
    ode/src/collision_quadtreespace.cpp
    ode/src/collision_space.cpp
    ode/src/collision_space_internal.h
    ode/src/collision_std.cpp
    ode/src/collision_std.h
    ode/src/collision_transform.cpp
    ode/src/collision_transform.h
    ode/src/collision_trimesh_internal.h
    ode/src/collision_util.cpp
    ode/src/collision_util.h
    ode/src/error.cpp
    ode/src/export-dif.cpp
    ode/src/fastdot.c
    ode/src/fastldlt.c
    ode/src/fastlsolve.c
    ode/src/fastltsolve.c
    ode/src/geom_internal.h
    ode/src/joint.cpp
    ode/src/joint.h
    ode/src/Lcp33.h
    ode/src/lcp.cpp
    ode/src/lcp.h
    ode/src/mass.cpp
    ode/src/mat.cpp
    ode/src/mat.h
    ode/src/matrix.cpp
    ode/src/memory.cpp
    ode/src/misc.cpp
    ode/src/objects.h
    ode/src/obstack.cpp
    ode/src/obstack.h
    ode/src/ode.cpp
    ode/src/odemath.cpp
    ode/src/quickstep.cpp
    ode/src/quickstep.h
    ode/src/rotation.cpp
    ode/src/stack.h
    ode/src/step.cpp
    ode/src/stepfast.cpp
    ode/src/step.h
    ode/src/StepJointInternal.cpp
    ode/src/StepJointInternal.h
    ode/src/testing.cpp
    ode/src/testing.h
    ode/src/timer.cpp
    ode/src/util.cpp
    ode/src/util.h
    include/ode/collision.h
    include/ode/collision_space.h
    include/ode/collision_trimesh.h
    include/ode/common.h
    include/ode/compatibility.h
    include/ode/config.h
    include/ode/contact.h
    include/ode/error.h
    include/ode/export-dif.h
    include/ode/geom.h
    include/ode/mass.h
    include/ode/matrix.h
    include/ode/memory.h
    include/ode/misc.h
    include/ode/objects.h
    include/ode/odecpp_collision.h
    include/ode/odecpp.h
    include/ode/ode.h
    include/ode/odemath.h
    include/ode/rotation.h
    include/ode/space.h
    include/ode/timer.h
    contrib/msvc7/ode_default/de_padf_integration.cpp
    contrib/msvc7/ode_default/de_padf_integration.h
)

target_include_directories(xrODE
    PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}/include"
)

# TODO platform-specific defines
target_compile_definitions(xrODE
    PUBLIC
    dSINGLE
    dNODEBUG

    PRIVATE
    LINUX
    __cdecl=
)

if (MASTER_GOLD)
    target_compile_definitions(xrODE
        PUBLIC
        dNODEBUG
    )
endif()

set_target_properties(xrODE PROPERTIES
    PREFIX ""
    POSITION_INDEPENDENT_CODE ON
    UNITY_BUILD OFF
)

if (NOT STATIC_BUILD)
    install(TARGETS xrODE LIBRARY
        DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    )
endif()

=== src/Layers/CMakeLists.txt ===
add_subdirectory(xrAPI)

# TODO test on Windows
if (WIN32)
    add_subdirectory(xrRenderPC_R4)
endif()

add_subdirectory(xrRenderPC_GL)

=== src/utils/CMakeLists.txt ===
add_subdirectory(xrMiscMath)

=== src/xrAICore/CMakeLists.txt ===
add_library(xrAICore SHARED)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI"
    FILES
    AISpaceBase.cpp
    AISpaceBase.hpp
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Component\\ProblemSolver"
    FILES
    Components/problem_solver.h
    Components/problem_solver_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Component\\ProblemSolver\\ConditionState"
    FILES
    Components/condition_state.h
    Components/condition_state_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Component\\ProblemSolver\\ConditionState\\ScriptWorldState"
    FILES
    Components/script_world_state.h
    Components/script_world_state_script.cpp
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Component\\ProblemSolver\\OperatorAbstract"
    FILES
    Components/operator_abstract.h
    Components/operator_abstract_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Component\\ProblemSolver\\OperatorCondition"
    FILES
    Components/operator_condition.h
    Components/operator_condition_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Component\\ProblemSolver\\OperatorCondition\\ScriptWorldProperty"
    FILES
    Components/script_world_property.h
    Components/script_world_property_inline.h
    Components/script_world_property_script.cpp
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\GameGraph"
    FILES
    Navigation/game_graph.h
    Navigation/game_graph_inline.h
    Navigation/game_graph_script.cpp
    Navigation/game_graph_space.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\GameLevelCrossTable"
    FILES
    Navigation/game_level_cross_table.h
    Navigation/game_level_cross_table_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\GraphAbstract"
    FILES
    Navigation/graph_abstract.h
    Navigation/graph_abstract_inline.h
    Navigation/graph_edge.h
    Navigation/graph_edge_inline.h
    Navigation/graph_vertex.h
    Navigation/graph_vertex_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\LevelGraph"
    FILES
    Navigation/level_graph.cpp
    Navigation/level_graph.h
    Navigation/level_graph_inline.h
    Navigation/level_graph_manager.h
    Navigation/level_graph_space.h
    Navigation/level_graph_vertex.cpp
    Navigation/level_graph_vertex_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\ObjectLocation"
    FILES
    Navigation/ai_object_location.h
    Navigation/ai_object_location_impl.h
    Navigation/ai_object_location_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\Algorithms\\AStar"
    FILES
    Navigation/a_star.h
    Navigation/a_star_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\Algorithms\\Dijkstra"
    FILES
    Navigation/dijkstra.h
    Navigation/dijkstra_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\DataStorages\\Constructors"
    FILES
    Navigation/data_storage_constructor.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\DataStorages\\PathBuilders"
    FILES
    Navigation/edge_path.h
    Navigation/edge_path_inline.h
    Navigation/vertex_path.h
    Navigation/vertex_path_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\DataStorages\\PriorityQueues"
    FILES
    Navigation/data_storage_binary_heap.h
    Navigation/data_storage_binary_heap_inline.h
    Navigation/data_storage_bucket_list.h
    Navigation/data_storage_bucket_list_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\DataStorages\\VertexAllocators"
    FILES
    Navigation/vertex_allocator_fixed.h
    Navigation/vertex_allocator_fixed_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\DataStorages\\VertexManagers"
    FILES
    Navigation/vertex_manager_fixed.h
    Navigation/vertex_manager_fixed_inline.h
    Navigation/vertex_manager_hash_fixed.h
    Navigation/vertex_manager_hash_fixed_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\GraphEngine"
    FILES
    Navigation/graph_engine.h
    Navigation/graph_engine_inline.h
    Navigation/graph_engine_space.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\PathManagers"
    FILES
    Navigation/PathManagers/path_manager.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\PathManagers\\Game"
    FILES
    Navigation/PathManagers/path_manager_game.h
    Navigation/PathManagers/path_manager_game_inline.h
    Navigation/PathManagers/path_manager_game_level.h
    Navigation/PathManagers/path_manager_game_level_inline.h
    Navigation/PathManagers/path_manager_game_vertex.h
    Navigation/PathManagers/path_manager_game_vertex_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\PathManagers\\Generic"
    FILES
    Navigation/PathManagers/path_manager_generic.h
    Navigation/PathManagers/path_manager_generic_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\PathManagers\\Level"
    FILES
    Navigation/PathManagers/path_manager_level.h
    Navigation/PathManagers/path_manager_level_inline.h
    Navigation/PathManagers/path_manager_level_flooder.h
    Navigation/PathManagers/path_manager_level_flooder_inline.h
    Navigation/PathManagers/path_manager_level_nearest_vertex.h
    Navigation/PathManagers/path_manager_level_nearest_vertex_inline.h
    Navigation/PathManagers/path_manager_level_straight_line.h
    Navigation/PathManagers/path_manager_level_straight_line_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\PathManagers\\Params"
    FILES
    Navigation/PathManagers/path_manager_params.h
    Navigation/PathManagers/path_manager_params_flooder.h
    Navigation/PathManagers/path_manager_params_game_level.h
    Navigation/PathManagers/path_manager_params_game_vertex.h
    Navigation/PathManagers/path_manager_params_nearest_vertex.h
    Navigation/PathManagers/path_manager_params_straight_line.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\Pathfinding\\PathManagers\\Solver"
    FILES
    Navigation/PathManagers/path_manager_solver.h
    Navigation/PathManagers/path_manager_solver_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\PatrolPath"
    FILES
    Navigation/PatrolPath/patrol_path.cpp
    Navigation/PatrolPath/patrol_path.h
    Navigation/PatrolPath/patrol_path_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\PatrolPath\\Params"
    FILES
    Navigation/PatrolPath/patrol_path_params.cpp
    Navigation/PatrolPath/patrol_path_params.h
    Navigation/PatrolPath/patrol_path_params_inline.h
    Navigation/PatrolPath/patrol_path_params_script.cpp
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\PatrolPath\\PatrolPoint"
    FILES
    Navigation/PatrolPath/patrol_point.cpp
    Navigation/PatrolPath/patrol_point.h
    Navigation/PatrolPath/patrol_point_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "AI\\Navigation\\PatrolPath\\Storage"
    FILES
    Navigation/PatrolPath/patrol_path_storage.cpp
    Navigation/PatrolPath/patrol_path_storage.h
    Navigation/PatrolPath/patrol_path_storage_inline.h
)

target_sources_grouped(
    TARGET xrAICore
    NAME "Kernel"
    FILES
    pch.cpp
    pch.hpp
)


target_include_directories(xrAICore
    PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_SOURCE_DIR}/src"
    "${CMAKE_SOURCE_DIR}/sdk/include"
)

target_link_libraries(xrAICore
    PRIVATE
    xrCore
    xrEngine
    xrMiscMath
    xrAPI
    xrScriptEngine
)

target_compile_definitions(xrAICore
    PRIVATE
    XRAICORE_EXPORTS
)

set_target_properties(xrAICore PROPERTIES
    PREFIX ""
)

target_precompile_headers(xrAICore
    PRIVATE
    pch.hpp
)

install(TARGETS xrAICore LIBRARY
    DESTINATION "${CMAKE_INSTALL_LIBDIR}"
)

=== debian/changelog ===
openxray (1.6.02-15) UNRELEASED; urgency=medium

  * Move to use gcc-14

 -- Krzysztof Sobiecki <sobkas@sobkas.io>  Tue, 07 May 2024 01:12:42 +0200

openxray (1.6.02-14) experimental; urgency=medium

  * Update *.install files

 -- Krzysztof Sobiecki <sobkas@sobkas.io>  Sat, 04 May 2024 20:15:57 +0200

openxray (1.6.02-13) experimental; urgency=medium

  * Update debian build infrastructure
  * Switch to quilt
  * Update source format
  * Add symbol file
  * Make packages multi-arch compliant
  * Explicit install files

 -- Krzysztof Sobiecki <sobkas@sobkas.io>  Sat, 19 Aug 2023 01:54:15 +0200

openxray (1.6.02-12-ubuntu1) disco; urgency=medium

  * move shlib to /usr/lib
  * try auto dep

  * fix build

 -- Ilya Orlov <eagleivg@mail.ru>  Sun, 23 Jun 2019 14:46:00 +0300

=== ArchLinux/PKGBUILD ===
# Contributor: chip_exe
# https://aur.archlinux.org/packages/openxray-git/
# <openxray@yahoo.com>
#This PKGBUILD compiles the package without downloading the source code. It is mainly intended for developers who use
#ArchLinux or Majaro.
#To build the package, open a terminal, go to the xray-16/ArchLinux directory and run the makepkg -fi command
#where the options are -f to overwrite the package if it was built before that -i install the package after the build.
pkgname=openxray-dev                                    
pkgver=1.6.02_
pkgrel=1          
pkgdesc="Unofficial X-Ray Engine Linux port by OpenXRay team (Originally developed by GSC Game World)"                                          
arch=('x86_64') 
url="https://github.com/OpenXRay/xray-16"
license=('custom:Custom 3-сlause BSD')
install="info.install"
makedepends=(gcc git cmake libglvnd libjpeg6-turbo ncurses pcre2 pcre)
depends=(glew sdl2 openal crypto++ freeimage libogg libtheora libvorbis lzo lzop libjpeg-turbo)
conflicts=(openxray openxray-git)

pkgver() {
  cd ../..
  printf 1.6.02_"$(git rev-parse --short HEAD)"
}

build() {
   cd ../..
#  rm -f -R bin
   mkdir -p bin
   cd bin
   cmake .. -DCMAKE_BUILD_TYPE=Release \
   -DCMAKE_INSTALL_PREFIX=/usr \
   -DCMAKE_INSTALL_LIBDIR=lib
   make
}

package() {
    cd ../../bin
    make DESTDIR="${pkgdir}/" install
    mkdir -p "${pkgdir}/usr/share/licenses/$pkgname/"
    cp ../License.txt "${pkgdir}/usr/share/licenses/$pkgname/"
}

=== debian/control ===
Source: openxray
Section: games
Priority: optional
Maintainer: lya Orlov <eagleivg@mail.ru>
Build-Depends:
 cmake,
 build-essential,
 libglew-dev,
 libegl1-mesa-dev,
 libgles2-mesa-dev,
 libopenal-dev,
 libcrypto++-dev,
 libfreeimage-dev,
 libfreeimageplus-dev,
 libogg-dev,
 libtheora-dev,
 libvorbis-dev,
 liblzo2-dev,
 libjpeg-dev,
 libncurses5-dev,
 gcc-14,
 libpcre3-dev,
 libsdl2-dev,
 g++-14,
 debhelper,
Build-Conflicts:
 libmimalloc-dev,
Homepage: https://github.com/OpenXRay/xray-16
Description: X-Ray Engine 1.6 expansion
 X-Ray Engine sources based on version 1.6.02. The original engine is used in S.T.A.L.K.E.R.: Call of Pripyat game released by GSC Game World.

Package: openxray
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 openxray-data (= ${source:Version}),
Pre-Depends: ${misc:Pre-Depends}
Description: ${source:Synopsis}
 ${source:Extended-Description}

Package: openxray-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: X-Ray Engine data files (modules, templates and documentation)
 ${source:Extended-Description}
 .
 This package provides openxray architecture independent data files (modules, templates, documentation etc.). Unless you have openxray installed, you probably do not need this package.

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
	export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
endif

%:
	dh $@ --buildsystem=cmake --parallel

extra_flags += \
-DCMAKE_C_COMPILER=gcc-14 \
-DCMAKE_CXX_COMPILER=g++-14 \
-DCMAKE_BUILD_TYPE="RelWithDebInfo" \
-DCMAKE_INSTALL_BINDIR="/usr/games" \
-DCMAKE_INSTALL_RPATH_USE_LINK_PATH=FALSE \
-DALLOW_RPATH=FALSE \
-DLUABIND_BUILD_SHARED=TRUE \
-DDISABLE_PORTABLE_MODE=TRUE

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_clean:
	rm -rf bin
	dh_clean

override_dh_missing:
	dh_missing --fail-missing
